#include "header.h"
#include "file.h"

/*************************************************************************/
/**	help printout functions, part 2					**/
/**									**/
/**	includes: helpoptable						**/
/**		  helpoptions						**/
/**		  helpopfile						**/
/**		  helphardcopy						**/
/**		  helpfkeys						**/
/**		  helpdisplaymenu					**/
/**		  helpanimalmenu					**/
/**		  helpcyclelenip					**/
/**									**/
/*************************************************************************/
/*
      5    10        20        30        40        50        60        70        80
  ----+----+----+----+----+----+----+----+----+----+----+----+----+----+----+----+
*/


/********************************/
/*     function: helpoptable	*/
/********************************/
helpoptable ()
{
#if PC
  int i;
  
  topline(" Output Table Explanation ");
  clrscr1(1);
  normvideo();
  i = 2;
  gotoxy(1, i++);
  cprintf("%sFor each cell traced, the program determines its position in the", tab4);
  gotoxy(1, i++);
  cprintf("%scycle after the user-specified number of days.  This can be either", tab4);
  gotoxy(1, i++);
  cprintf("%sforward (positive days) or backward (negative days) in time.", tab4);
  i++;
  gotoxy(1, i++);
  cprintf("%sSince it may not be known exactly how far along in a stage an observed", tab4);
  gotoxy(1, i++);
  cprintf("%scell is, the program determines the cycle position reached from four", tab4);
  gotoxy(1, i++);
  cprintf("%spoints in the initial stage:  at the beginning, at the first third,", tab4);
  gotoxy(1, i++);
  cprintf("%sat the second third, and at the end.", tab4);
  hitreturn(1);
  clrscr1(1);
  i = 2;;
  gotoxy(1, i++);
  cprintf("%sThe output table shows the cycle position reached for each initial", tab4);
  gotoxy(1, i++);
  cprintf("%scell, had that cell started in the first third, middle third, or", tab4);
  gotoxy(1, i++);
  cprintf("%slast third of its initial stage.", tab4);
  i++;
  gotoxy(1, i++);
  highvideo();
  cprintf("%sPre-Entry", tab4);
  normvideo();
  cprintf(" or ");
  highvideo();
  cprintf("PreEnt");
  normvideo();
  cprintf(" means that the given number of days was greater");
  gotoxy(1, i++);
  cprintf("%sthan the time the cell had existed in the cycle; ", tab4);
  highvideo();
  cprintf("Ejaculate");
  normvideo();
  cprintf(" or ");
  highvideo();
  cprintf("Ejact");
  normvideo();
  gotoxy(1, i++);
  cprintf("%smeans that the specified days was greater than the time required", tab4);
  gotoxy(1, i++);
  cprintf("%sfor spermiation to occur.", tab4);
  i++;
  gotoxy(1, i++);
  highvideo();
  cprintf("%sEpididymis", tab4);
  normvideo();
  cprintf(" means that spermiation has occurred, and the cell is moving");
  gotoxy(1, i++);
  cprintf("%sthrough the epididymis.  NOTE: The transit time used is only an", tab4);
  gotoxy(1, i++);
  cprintf("%sestimate; the actual transit time depends upon the sexual activity of", tab4);
  gotoxy(1, i++);
  cprintf("%sthe animal.", tab4);
  hitreturn(1);
  clrscr1(1);
  i = 2;
  gotoxy(1, i++);
  cprintf("%sIf the number of days causes the specified initial cell to move", tab4);
  gotoxy(1, i++);
  cprintf("%sbeyond the boundaries of the cycle (epididymis or ejaculate, if", tab4);
  gotoxy(1, i++);
  cprintf("%smoving forward; pre-entry, if moving backward), then the output", tab4);
  gotoxy(1, i++);
  cprintf("%stable will show the correct stage of spermatogenesis that cells", tab4);
  gotoxy(1, i++);
  cprintf("%sin the same stage as the initial cell would have reached.", tab4);
  i++;
  gotoxy(1, i++);
  cprintf("%sFor example, suppose the Sprague-Dawley Rat is the animal being", tab4);
  gotoxy(1, i++);
  cprintf("%sstudied.  If the initial cell is A1-9 and Stages is used to", tab4);
  gotoxy(1, i++);
  cprintf("%spredict where that cell will be in 68 days, that particular cell", tab4);
  gotoxy(1, i++);
  cprintf("%swould have completed spermatogenesis after just 51.6 days; but", tab4);
  gotoxy(1, i++);
  cprintf("%sthe output table would show that younger cells that started in stage", tab4);
  gotoxy(1, i++);
  cprintf("%s9 of the cycle would have ended up in stage 14, after 68 days.", tab4);
  hitreturn(1);
  if (HARDCOPY) {
    togglepr();
    fprintf(stdprn, "\n\n");
    printline(2, LNWID, '-');
    fprintf(stdprn, "\n\t\t    Output Table Explanation\n\n");
    fprintf(stdprn, "\tFor each cell tracked, the program determines its position in the\n");
    fprintf(stdprn, "\tcycle after the user-specified number of days.  This can be either\n");
    fprintf(stdprn, "\tforward (positive days) or backward (negative days) in time.\n\n");
    fprintf(stdprn, "\tSince it may not be known exactly how far along in a stage an observed\n");
    fprintf(stdprn, "\tcell is, the program determines the cycle position reached from four\n");
    fprintf(stdprn, "\tpoints in the initial stage:  at the beginning, at the first third,\n");
    fprintf(stdprn, "\tat the second third, and at the end.\n\n");
    fprintf(stdprn, "\tThe output table shows the cycle position reached for each initial\n");
    fprintf(stdprn, "\tcell, had that cell started in the first third, middle third, or\n");
    fprintf(stdprn, "\tlast third of its initial stage.\n\n");
    fprintf(stdprn, "\tPre-Entry or PreEnt means that the given number of days was greater\n");
    fprintf(stdprn, "\tthan the time the cell had existed in the cycle; Ejaculate or Ejact\n");
    fprintf(stdprn, "\tmeans that the specified days was greater than the time required\n");
    fprintf(stdprn, "\tfor spermiation to occur.\n\n");
    fprintf(stdprn, "\tEpididymis means that spermiation has occurred, and the cell is moving\n");
    fprintf(stdprn, "\tthrough the epididymis.  NOTE: The transit time used is only an\n");
    fprintf(stdprn, "\testimate; the actual transit time depends upon the sexual activity of\n");
    fprintf(stdprn, "\tthe animal.\n\n");
    printline(2, LNWID, '-');
  }
#else
  printf("\n\n");
  printline(0, LNWID, '-');
  printf("\n\t\t    Output Table Explanation\n\n");
  printf("\tFor each cell tracked, the program determines its position in the\n");
  printf("\tcycle after the user-specified number of days.  This can be either\n");
  printf("\tforward (positive days) or backward (negative days) in time.\n\n");
  printf("\tSince it may not be known exactly how far along in a stage an observed\n");
  printf("\tcell is, the program determines the cycle position reached from four\n");
  printf("\tpoints in the initial stage:  at the beginning, at the first third,\n");
  printf("\tat the second third, and at the end.\n\n");
  printf("\tThe output table shows the cycle position reached for each initial\n");
  printf("\tcell, had that cell started in the first third, middle third, or\n");
  printf("\tlast third of its initial stage.\n\n");
  printf("\tPre-Entry or PreEnt means that the given number of days was greater\n");
  printf("\tthan the time the cell had existed in the cycle; Ejaculate or Ejact\n");
  printf("\tmeans that the specified days was greater than the time required\n");
  printf("\tfor spermiation to occur.\n\n");
  printf("\tEpididymis means that spermiation has occurred, and the cell is moving\n");
  printf("\tthrough the epididymis.  NOTE: The transit time used is only an\n");
  printf("\testimate; the actual transit time depends upon the sexual activity of\n");
  printf("\tthe animal.\n");
  printline(0, LNWID, '-');
#endif
#if VERBOSE
  if (FILEq && FILECOPY) {
    fprintf(fpout, "\n\n");
    printline(1, LNWID, '-');
    fprintf(fpout, "\n\t\t    Output Table Explanation\n\n");
    fprintf(fpout, "\tFor each cell tracked, the program determines its position in the\n");
    fprintf(fpout, "\tcycle after the user-specified number of days.  This can be either\n");
    fprintf(fpout, "\tforward (positive days) or backward (negative days) in time.\n\n");
    fprintf(fpout, "\tSince it may not be known exactly how far along in a stage an observed\n");
    fprintf(fpout, "\tcell is, the program determines the cycle position reached from four\n");
    fprintf(fpout, "\tpoints in the initial stage:  at the beginning, at the first third,\n");
    fprintf(fpout, "\tat the second third, and at the end.\n\n");
    fprintf(fpout, "\tThe output table shows the cycle position reached for each initial\n");
    fprintf(fpout, "\tcell, had that cell started in the first third, middle third, or\n");
    fprintf(fpout, "\tlast third of its initial stage.\n\n");
    fprintf(fpout, "\tPre-Entry or PreEnt means that the given number of days was greater\n");
    fprintf(fpout, "\tthan the time the cell had existed in the cycle; Ejaculate or Ejact\n");
    fprintf(fpout, "\tmeans that the specified days was greater than the time required\n");
    fprintf(fpout, "\tfor spermiation to occur.\n\n");
    fprintf(fpout, "\tEpididymis means that spermiation has occurred, and the cell is moving\n");
    fprintf(fpout, "\tthrough the epididymis.  NOTE: The transit time used is only an\n");
    fprintf(fpout, "\testimate; the actual transit time depends upon the sexual activity of\n");
    fprintf(fpout, "\tthe animal.\n");
    printline(1, LNWID, '-');
  }
#endif
  return(0);
} /* helpoptable */

/********************************/
/*     function: helpoptions	*/
/********************************/
/* this is really a menu */
helpoptions (opfil)
  char *opfil;		/* name of opfil: "stages.out" */
{
  int valid;
  char input[MAXLEN];
#if PC
  int i, val;
  
  topline(" Printer and File Options ");
  clrscr1(1);
  normvideo();
  i = 2;
  gotoxy(1, i++);
  cprintf("%sOutput from Stages may be printed out on your printer, or saved", tab);
  gotoxy(1, i++);
  cprintf("%sin a file in the current working directory.  You can change the", tab);
  gotoxy(1, i++);
  cprintf("%sdefault setting of the output file here, for this run of Stages.", tab);
  i++;
  gotoxy(1, i++);
  cprintf("%sDefault setting:", tab);
  i++;
/*
  gotoxy(1, i++);
  cprintf("%s         PRINTER:  Deactivated", tab);
*/
  gotoxy(1, i++);
  cprintf("%s            FILE:  Do not send output to a file", tab);
  hitreturn(1);
  clrscr1(1);
  i = 2;
  gotoxy(1, i++);
  cprintf("%sPrinter Use:", tab);
  i++;
  gotoxy(1, i++);
  cprintf("%s(see also Help Menu, `Help!: Saving Output to a Printer')", tab);
  i++;
  gotoxy(1, i++);
  cprintf("%sThe information on any screen can be sent to the printer by using", tab);
  gotoxy(1, i++);
  cprintf("%sthe F8 function key on your keyboard.  The F8 key works like the", tab);
  gotoxy(1, i++);
  cprintf("%sPrintScreen key on your keyboard, except that F8 prints a little", tab);
  gotoxy(1, i++);
  cprintf("%sfaster, since only the important information is printed.", tab);
  hitreturn(1);
  if (HARDCOPY) {
    togglepr();
    fprintf(stdprn, "\n\n");
    printline(2, LNWID, '-');
    fprintf(stdprn, "\n\t\t    Printer and File Options\n\n");
    fprintf(stdprn, "\tOutput from Stages may be printed out on your printer, or saved\n");
    fprintf(stdprn, "\tin a file in the current working directory.  You can change the\n");
    fprintf(stdprn, "\tdefault setting of the output file here, for this run of Stages.\n\n");
    fprintf(stdprn, "\tDefault setting:\n");
/*
    fprintf(stdprn, "\t         PRINTER:  Deactivated\n");
*/
    fprintf(stdprn, "\t            FILE:  Do not send output to a file\n\n");
    fprintf(stdprn, "\tPrinter Use:\n");
    fprintf(stdprn, "\t(see also Help Menu, `Help!: Saving Output to a Printer')\n\n");
    fprintf(stdprn, "\tThe information on any screen can be sent to the printer, by using\n");
    fprintf(stdprn, "\tthe F8 function key on your keyboard.  The F8 key works like the\n");
    fprintf(stdprn, "\tPrintScreen key on your keyboard, except that F8 prints a little\n");
    fprintf(stdprn, "\tfaster, since only the important information is printed.\n");
    printline(2, LNWID, '-');
  }
#else
  printf("\n\n");
  printline(0, LNWID, '-');
  printf("\n\t\t    Printer and File Options\n\n");
  printf("\tOutput from Stages may be printed out on your printer, or saved\n");
  printf("\tin a file in the current working directory.  You can change the\n");
  printf("\tdefault setting of the output file here, for this run of Stages.\n\n");
  printf("\tDefault setting:\n");
/*
  printf("\t         PRINTER:  Deactivated\n");
*/
  printf("\t            FILE:  Do not send output to a file\n\n");
  printf("\tPrinter Use:\n");
  printf("\t(see also Help Menu, `Help!: Saving Output to a Printer')\n\n");
  printf("\tThe information on any screen can be sent to the printer, by using\n");
  printf("\tthe F8 function key on your keyboard.  The F8 key works like the\n");
  printf("\tPrintScreen key on your keyboard, except that F8 prints a little\n");
  printf("\tfaster, since only the important information is printed.\n");
  printline(0, LNWID, '-');
#endif
#if VERBOSE
  if (FILEq && FILECOPY) {
    fprintf(fpout, "\n\n");
    printline(1, LNWID, '-');
    fprintf(fpout, "\n\t\t    Printer and File Options\n\n");
    fprintf(fpout, "\tOutput from Stages may be printed out on your printer, or saved\n");
    fprintf(fpout, "\tin a file in the current working directory.  You can change the\n");
    fprintf(fpout, "\tdefault setting of the output file here, for this run of Stages.\n\n");
    fprintf(fpout, "\tDefault setting:\n");
/*
    fprintf(fpout, "\t         PRINTER:  Deactivated\n");
*/
    fprintf(fpout, "\t            FILE:  Do not send output to a file\n\n");
    fprintf(fpout, "\tPrinter Use:\n");
    fprintf(fpout, "\t(see also Help Menu, `Help!: Saving Output to a Printer')\n\n");
    fprintf(fpout, "\tThe information on any screen can be sent to the printer, by using\n");
    fprintf(fpout, "\tthe F8 function key on your keyboard.  The F8 key works like the\n");
    fprintf(fpout, "\tPrintScreen key on your keyboard, except that F8 prints a little\n");
    fprintf(fpout, "\tfaster, since only the important information is printed.\n");
    printline(1, LNWID, '-');
  }
#endif

  valid = 0;
  while (! valid) {

#if PC
    clrscr1(1);
    i = 2;
    gotoxy(1, i++);
    cprintf("%sOutput to File <stages.out>:", tab);
    i++;
    gotoxy(1, i++);
    cprintf("%sPlease select one option.", tab);
    gotoxy(1, i++);
    cprintf("%s    A:  Do not send output to file (default)", tab);
    gotoxy(1, i++);
    cprintf("%s    B:  Send output to file stages.out, overwrite", tab);
    gotoxy(1, i++);
    cprintf("%s    C:  Send output to file stages.out, append", tab);
    gotoxy(1, i++);
    cprintf("%s    D:  Quit menu, do not change file status", tab);
    i++;
    clrscr1(2);
    cprintf("%sPlease enter your choice:", tab);
    gotoxy(1, 2);
    highvideo();
    cprintf("%s%c%c%c ", tab2, HBAR, HBAR, RTRI);
    normvideo();
    val = getusrstr(input);
    if (HARDCOPY) {
      togglepr();
      fprintf(stdprn, "\n\t\t    Output to File <stages.out>:\n\n");
      fprintf(stdprn, "\tPlease select one option.\n\n");
      fprintf(stdprn, "\t    A:  Do not send output to file (default)\n");
      fprintf(stdprn, "\t    B:  Send output to file stages.out, overwrite\n");
      fprintf(stdprn, "\t    C:  Send output to file stages.out, append\n");
      fprintf(stdprn, "\t    D:  Quit menu, do not change file status\n");
      fprintf(stdprn, "\n\tPlease enter your choice:\n");
      fprintf(stdprn, "\t\t==> %s", input);
    }
#else
    printf("\n\t\t    Output to File <stages.out>:\n\n");
    printf("\tPlease select one option.\n\n");
    printf("\t    A:  Do not send output to file (default)\n");
    printf("\t    B:  Send output to file stages.out, overwrite\n");
    printf("\t    C:  Send output to file stages.out, append\n");
    printf("\t    D:  Quit menu, do not change file status\n");
    printf("\n\tPlease enter your choice:\n");
    printf("\t\t==> ");
    getusrstr(input);
#endif
#if VERBOSE
    if (FILEq && FILECOPY) {
      fprintf(fpout, "\n\t\t    Output to File <stages.out>:\n\n");
      fprintf(fpout, "\tPlease select one option.\n\n");
      fprintf(fpout, "\t    A:  Do not send output to file (default)\n");
      fprintf(fpout, "\t    B:  Send output to file stages.out, overwrite\n");
      fprintf(fpout, "\t    C:  Send output to file stages.out, append\n");
      fprintf(fpout, "\t    D:  Quit menu, do not change file status\n");
      fprintf(fpout, "\n\tPlease enter your choice:\n");
      fprintf(fpout, "\t\t==> %s", input);
    }
#endif
    
#if PC
    if (val) return(val);
#endif
    switch (toupper1(input[0])) {

    case 'A':		/* no file */
      valid = 1;
      FILEq = 0;
      FILECOPY = 0;
      break;

    case 'B':		/* file, overwrite */
      valid = 1;
      FILEq = 1;
      FILECOPY = 1;
      fpout = fopen("stages.out", "w");
      strcpy(opfil, "stages.out");
      printintro(0, 1);
#if PC
      printFILECOPY();
#endif
      break;

    case 'C':		/* file, append */
      valid = 1;
      FILEq = 1;
      FILECOPY = 1;
      fpout = fopen("stages.out", "a");
      strcpy(opfil, "stages.out");
      printintro(0, 1);
#if PC
      printFILECOPY();
#endif
      break;

    case 'D':		/* quit, no change */
      valid = 1;
      break;
      
    default:
      FILEq = 0;
      FILECOPY = 0;
#if PC
      clrscr1(3);
      printf("%s%sInvalid choice:  <%c>.", tab, ERRSTR, input[0]);
      if (HARDCOPY) {
	togglepr();
	fprintf(stdprn, "\t%sInvalid choice:  <%c>.", ERRSTR, input[0]);
      }
#else
      printf("\t%sInvalid choice:  <%c>.", ERRSTR, input[0]);
#endif
      if (FILEq && FILECOPY)
	fprintf(fpout, "\t%sInvalid choice:  <%c>.", ERRSTR, input[0]);
    } /* switch */

    if (FILEq) {
#if PC
      outputwin();
      gotoxy(1, i++);
      cprintf("%sWriting to the file stages.out can be started and stopped at", tab);
      gotoxy(1, i++);
      cprintf("%sany time by pressing the F7 function key on your keyboard.  An", tab);
      gotoxy(1, i++);
      cprintf("%sannunciator at the bottom left corner of the screen indicates", tab);
      gotoxy(1, i++);
      cprintf("%sthe current file output status.", tab);
      hitreturn(1);
      if (HARDCOPY) {
	togglepr();
	fprintf(stdprn, "\tWriting to the file stages.out can be started and stopped at\n");
	fprintf(stdprn, "\tany time by pressing the F7 function key on your keyboard.  An\n");
	fprintf(stdprn, "\t annunciator at the bottom left corner of the screen indicates\n");
	fprintf(stdprn, "\tthe current file output status.\n");
      }
#endif
#if VERBOSE
      if (FILEq && FILECOPY) {
	fprintf(fpout, "\tWriting to the file stages.out can be started and stopped at\n");
	fprintf(fpout, "\tany time by pressing the F7 function key on your keyboard.  An\n");
	fprintf(fpout, "\tannunciator at the bottom left corner of the screen indicates\n");
	fprintf(fpout, "\tthe current file output status.\n");
      }
#endif
    } /* if FILEq */
  } /* while */
  return(0);
} /* helpoptions */

/********************************/
/*     function: helpopfile	*/
/********************************/
helpopfile ()
{
#if PC
  int i;
  
  topline(" Help!: Saving Output to a File ");
  clrscr1(1);
  normvideo();
  i = 2;
  gotoxy(1, i++);
  cprintf("%sThe output generated by Stages can be saved in an output file", tab);
  gotoxy(1, i++);
  cprintf("%scalled stages.out in the current working directory.  Data can", tab);
  gotoxy(1, i++);
  cprintf("%soverwrite or be appended to an existing copy of stages.out.", tab);
  i++;
  gotoxy(1, i++);
  cprintf("%sBy default, no output file stages.out is created.  If you", tab);
  gotoxy(1, i++);
  cprintf("%swant to save this Stages session's output in stages.out, choose", tab);
  gotoxy(1, i++);
  cprintf("%s`Printer and File Options' at the General Menu.", tab);
  hitreturn(1);
  if (HARDCOPY) {
    togglepr();
    fprintf(stdprn, "\n\n");
    printline(2, LNWID, '-');
    fprintf(stdprn, "\n\t\t    Help!: Saving Output to a File\n\n");
    fprintf(stdprn, "\tThe output generated by Stages can be saved in an output file\n");
    fprintf(stdprn, "\tcalled stages.out in the current working directory.  Data can\n");
    fprintf(stdprn, "\toverwrite or be appended to an existing copy of stages.out.\n\n");
    fprintf(stdprn, "\tBy default, no output file stages.out is created.  If you\n");
    fprintf(stdprn, "\twant to save this Stages session's output in stages.out, choose\n");
    fprintf(stdprn, "\t`Printer and File Options' at the General Menu.\n");
    printline(2, LNWID, '-');
  }
#else
  printf("\n\n");
  printline(0, LNWID, '-');
  printf("\n\t\t    Help!: Saving Output to a File\n\n");
  printf("\tThe output generated by Stages can be saved in an output file\n");
  printf("\tcalled stages.out in the current working directory.  Data can\n");
  printf("\toverwrite or be appended to an existing copy of stages.out.\n\n");
  printf("\tBy default, no output file stages.out is created.  If you\n");
  printf("\twant to save this Stages session's output in stages.out, choose\n");
  printf("\t`Printer and File Options' at the General Menu.\n");
  printline(0, LNWID, '-');
#endif
#if VERBOSE
  if (FILEq && FILECOPY) {
    fprintf(fpout, "\n\n");
    printline(1, LNWID, '-');
    fprintf(fpout, "\n\t\t    Help!: Saving Output to a File\n\n");
    fprintf(fpout, "\tThe output generated by Stages can be saved in an output file\n");
    fprintf(fpout, "\tcalled stages.out in the current working directory.  Data can\n");
    fprintf(fpout, "\toverwrite or be appended to an existing copy of stages.out.\n\n");
    fprintf(fpout, "\tBy default, no output file stages.out is created.  If you\n");
    fprintf(fpout, "\twant to save this Stages session's output in stages.out, choose\n");
    fprintf(fpout, "\t`Printer and File Options' at the General Menu.\n");
    printline(1, LNWID, '-');
  }
#endif
  return(0);
} /* helpopfile */

#if PC
/********************************/
/*     function: helphardcopy	*/
/********************************/
helphardcopy ()
{
  int i;

  topline(" Help!: Sending Output to a Printer ");
  clrscr1(1);
  normvideo();
  i = 2;
  gotoxy(1, i++);
  cprintf("%sTo record any information presented on this terminal screen, either:", tab);
  i++;
  gotoxy(1, i++);
  cprintf("%s  1/  Use the PrintScreen key on your keyboard, if one exists, or", tab);
  gotoxy(1, i++);
  cprintf("%s  2/  Use the F8 function key on your keyboard.", tab);
  i++;
  gotoxy(1, i++);
  cprintf("%sThe F8 key works a little faster than the PrintScreen key, because", tab);
  gotoxy(1, i++);
  cprintf("%sonly the important information on the screen will be sent to the", tab);
  gotoxy(1, i++);
  cprintf("%sprinter.", tab);
  hitreturn(1);
  if (HARDCOPY) {
    togglepr();
    fprintf(stdprn, "\n\n");
    printline(2, LNWID, '-');
    fprintf(stdprn, "\n\t\t    Help!: Sending Output to a Printer\n\n");
    fprintf(stdprn, "\tTo record any information presented on this terminal screen, either:\n");
    fprintf(stdprn, "\t  1/  Use the PrintScreen key on your keyboard, if one exists, or\n");
    fprintf(stdprn, "\t  2/  Use the F8 function key on your keyboard.\n");
    fprintf(stdprn, "\tThe F8 key works a little faster than the PrintScreen key, because\n");
    fprintf(stdprn, "\tonly the important information on the screen will be sent to the\n");
    fprintf(stdprn, "\tprinter.\n");
    printline(2, LNWID, '-');
  }

#if VERBOSE
  if (FILEq && FILECOPY) {
    fprintf(fpout, "\n\n");
    printline(1, LNWID, '-');
    fprintf(fpout, "\n\t\t    Help!: Sending Output to a Printer\n\n");
    fprintf(fpout, "\tTo record any information presented on this terminal screen, either:\n");
    fprintf(fpout, "\t  1/  Use the PrintScreen key on your keyboard, if one exists, or\n");
    fprintf(fpout, "\t  2/  Use the F8 function key on your keyboard.\n");
    fprintf(fpout, "\tThe F8 key works a little faster than the PrintScreen key, because\n");
    fprintf(fpout, "\tonly the important information on the screen will be sent to the\n");
    fprintf(fpout, "\tprinter.\n");
    printline(1, LNWID, '-');
  }
#endif
  return(0);
} /* helphardcopy */

/********************************/
/*     function: helpfkeys	*/
/********************************/
helpfkeys ()
{
  int i;
  
  topline(" Help!: Using the F1-F10 Keys ");
  clrscr1(1);
  normvideo();
  i = 2;
  gotoxy(1, i++);
  cprintf("%sThe ten function keys, F1-F10, have been defined as follows:", tab);
  i++;
  gotoxy(1, i++);
  cprintf("%sF1: go to General Menu        F7: Toggle output to file", tab);
  gotoxy(1, i++);
  cprintf("%sF2: go to Help Menu           F8: Print screen", tab);
  gotoxy(1, i++);
  cprintf("%sF3: go to Animal Menu         F9: Refresh the screen", tab);
  gotoxy(1, i++);
  cprintf("%sF4: go to Cycle Length Menu  F10: Exit the program", tab);
  gotoxy(1, i++);
  cprintf("%sF5: go to Cell Input Menu", tab);
  gotoxy(1, i++);
  cprintf("%sF6: go to Days Input Menu", tab);
  i++;
  gotoxy(1, i++);
  cprintf("%sThe F-keys can be used any time Stages asks for input.  However,", tab);
  gotoxy(1, i++);
  cprintf("%sif pressed as response to `Press any key to continue:', their", tab);
  gotoxy(1, i++);
  cprintf("%sspecial functions are not performed -- except for the F8 key,", tab);
  gotoxy(1, i++);
  cprintf("%swhich will still print out the current screen's information.", tab);
  hitreturn(1);
  if (HARDCOPY) {
    togglepr();
    fprintf(stdprn, "\n\n");
    printline(2, LNWID, '-');
    fprintf(stdprn, "\n\t\t    Help!: Using the F1-F10 Keys\n\n");
    fprintf(stdprn, "\tThe ten function keys, F1-F10, have been defined as follows:\n\n");
    fprintf(stdprn, "\tF1: go to General Menu       F7: Toggle output to file\n");
    fprintf(stdprn, "\tF2: go to Help Menu          F8: Print screen\n");
    fprintf(stdprn, "\tF3: go to Animal Menu      F9: Refresh the screen\n");
    fprintf(stdprn, "\tF4: go to Display Menu      F10: Exit the program\n");
    fprintf(stdprn, "\tF5: go to Cell Input Menu\n");
    fprintf(stdprn, "\tF6: go to Days Input Menu\n");
    fprintf(stdprn, "\tThe F-keys can be used any time Stages asks for input.  However,\n\n");
    fprintf(stdprn, "\tif pressed as response to `Press any key to continue:', their\n");
    fprintf(stdprn, "\tspecial functions are not performed -- except for the F8 key,\n");
    fprintf(stdprn, "\twhich will still print out the current screen's information.\n");
    printline(2, LNWID, '-');
  }
#if VERBOSE
  if (FILEq && FILECOPY) {
    fprintf(fpout, "\n\n");
    printline(1, LNWID, '-');
    fprintf(fpout, "\n\t\t    Help!: Using the F1-F10 Keys\n\n");
    fprintf(fpout, "\tThe ten function keys, F1-F10, have been defined as follows:\n\n");
    fprintf(fpout, "\tF1: go to General Menu       F7: Toggle output to file\n");
    fprintf(fpout, "\tF2: go to Help Menu          F8: Print screen\n");
    fprintf(fpout, "\tF3: go to Animal Menu      F9: Refresh the screen\n");
    fprintf(fpout, "\tF4: go to Display Menu      F10: Exit the program\n");
    fprintf(fpout, "\tF5: go to Cell Input Menu\n");
    fprintf(fpout, "\tF6: go to Days Input Menu\n");
    fprintf(fpout, "\tThe F-keys can be used any time Stages asks for input.  However,\n\n");
    fprintf(fpout, "\tif pressed as response to `Press any key to continue:', their\n");
    fprintf(fpout, "\tspecial functions are not performed -- except for the F8 key,\n");
    fprintf(fpout, "\twhich will still print out the current screen's information.\n");
    printline(1, LNWID, '-');
  }
#endif
  return(0);
} /* helpfkeys */

#endif

/********************************/
/*     function: helpdisplaymenu*/
/********************************/
helpdisplaymenu ()
{
#if PC
  int i;
  
  topline(" Help!: Using the Display Menu ");
  clrscr1(1);
  normvideo();
  i = 2;
  gotoxy(1, i++);
  if (strcmp(Animal, "None"))
    cprintf("%sThis menu allows you to display data on the %s.", tab, Animal);
  else
    cprintf("%sThis menu allows you to display data on the current animal.", tab);
  i++;
  gotoxy(1, i++);
  cprintf("%sChoosing `Stage Length Data' will display the stages and their", tab);
  gotoxy(1, i++);
  cprintf("%sassociated lengths (in days), along with the cycle length (in", tab);
  gotoxy(1, i++);
  cprintf("%sdays) and a reference for these data.", tab);
  i++;
  gotoxy(1, i++);
  cprintf("%sChoosing `Cell Sequence Data' will display the cell names in", tab);
  gotoxy(1, i++);
  cprintf("%sthe correct order of spermatogenesis.  These cell names are", tab);
  gotoxy(1, i++);
  cprintf("%sin the proper syntax that Stages uses and expects as input", tab);
  gotoxy(1, i++);
  cprintf("%sfrom the user.", tab);
  hitreturn(1);
  if (HARDCOPY) {
    togglepr();
    fprintf(stdprn, "\n\n");
    printline(2, LNWID, '-');
    fprintf(stdprn, "\n\t\t    Help!: Using the Display Menu\n\n");
    if (strcmp(Animal, "None"))
      fprintf(stdprn, "\tThis menu allows you to display data on the %s.\n", Animal);
    else
      fprintf(stdprn, "\tThis menu allows you to display data on the current animal.\n");
    fprintf(stdprn, "\tChoosing `Stage Length Data' will display the stages and their\n");
    fprintf(stdprn, "\tassociated lengths (in days), along with the cycle length (in\n");
    fprintf(stdprn, "\tdays) and a reference for these data.\n\n");
    fprintf(stdprn, "\tChoosing `Cell Sequence Data' will display the cell names in\n");
    fprintf(stdprn, "\tthe correct order of spermatogenesis.  These cell names are\n");
    fprintf(stdprn, "\tin the proper syntax that Stages uses and expects as\n");
    fprintf(stdprn, "\tinput from the user.\n");
    printline(2, LNWID, '-');
  }
#else
  printf("\n\n");
  printline(0, LNWID, '-');
  printf("\n\t\t    Help!: Using the Display Menu\n\n");
  if (strcmp(Animal, "None"))
    printf("\tThis menu allows you to display data on the %s.\n", Animal);
  else
    printf("\tThis menu allows you to display data on the current animal.\n");
  printf("\tChoosing `Stage Length Data' will display the stages and their\n");
  printf("\tassociated lengths (in days), along with the cycle length (in\n");
  printf("\tdays) and a reference for these data.\n\n");
  printf("\tChoosing `Cell Sequence Data' will display the cell names in\n");
  printf("\tthe correct order of spermatogenesis.  These cell names are\n");
  printf("\tin the proper syntax that Stages uses and expects as\n");
  printf("\tinput from the user.\n");
  printline(0, LNWID, '-');
#endif
#if VERBOSE
  if (FILEq && FILECOPY) {
    fprintf(fpout, "\n\n");
    printline(1, LNWID, '-');
    fprintf(fpout, "\n\t\t    Help!: Using the Display Menu\n\n");
    if (strcmp(Animal, "None"))
      fprintf(fpout, "\tThis menu allows you to display data on the %s.\n", Animal);
    else
      fprintf(fpout, "\tThis menu allows you to display data on the current animal.\n");
    fprintf(fpout, "\tChoosing `Stage Length Data' will display the stages and their\n");
    fprintf(fpout, "\tassociated lengths (in days), along with the cycle length (in\n");
    fprintf(fpout, "\tdays) and a reference for these data.\n\n");
    fprintf(fpout, "\tChoosing `Cell Sequence Data' will display the cell names in\n");
    fprintf(fpout, "\tthe correct order of spermatogenesis.  These cell names are\n");
    fprintf(fpout, "\tin the proper syntax that Stages uses and expects as\n");
    fprintf(fpout, "\tinput from the user.\n");
    printline(1, LNWID, '-');
  }
#endif
  return(0);
} /* helpdisplaymenu */

/********************************/
/*     function: helpanimalmenu	*/
/********************************/
helpanimalmenu ()
{
#if PC
  int i;
  
  topline(" Help!: Using the Animal Menu ");
  clrscr1(1);
  normvideo();
  i = 2;
  gotoxy(1, i++);
  cprintf("%sStages needs an animal type.  Once an animal has been selected,", tab);
  gotoxy(1, i++);
  cprintf("%sStages can read the appropriate files to obtain the data on that", tab);
  gotoxy(1, i++);
  cprintf("%sanimal's cycle of the seminiferous epithelium.", tab);
  i++;
  gotoxy(1, i++);
  cprintf("%sStages can access the data for the following animals:", tab);
  i++;
  gotoxy(1, i++);
  cprintf("%s      1/  Sprague-Dawley Rat", tab);
  gotoxy(1, i++);
  cprintf("%s      2/  Sherman Rat", tab);
  gotoxy(1, i++);
  cprintf("%s      3/  Hamster", tab);
  gotoxy(1, i++);
  cprintf("%s      4/  C3H Mouse", tab);
  gotoxy(1, i++);
  cprintf("%s      5/  Dog", tab);
  i++;
  gotoxy(1, i++);
  cprintf("%sStages cannot proceed until an animal is selected.", tab);
  hitreturn(1);
  if (HARDCOPY) {
    togglepr();
    fprintf(stdprn, "\n\n");
    printline(2, LNWID, '-');
    fprintf(stdprn, "\n\t\t    Help!: Using the Animal Menu\n\n");
    fprintf(stdprn, "\tStages needs an animal type.  Once an animal has been selected,\n");
    fprintf(stdprn, "\tStages can read the appropriate files to obtain the data on that\n");
    fprintf(stdprn, "\tanimal's cycle of the seminiferous epithelium.\n\n");
    fprintf(stdprn, "\tStages can access the data for the following animals:\n\n");
    fprintf(stdprn, "\t      1/  Sprague-Dawley Rat\n");
    fprintf(stdprn, "\t      2/  Sherman Rat\n");
    fprintf(stdprn, "\t      3/  Hamster\n");
    fprintf(stdprn, "\t      4/  C3H Mouse\n");
    fprintf(stdprn, "\t      5/  Dog\n\n");
    fprintf(stdprn, "\tStages cannot proceed until an animal is selected.\n");
    printline(2, LNWID, '-');
  }
#else
  printf("\n\n");
  printline(0, LNWID, '-');
  printf("\n\t\t    Help!: Using the Animal Menu\n\n");
  printf("\tStages needs an animal type.  Once an animal has been selected,\n");
  printf("\tStages can read the appropriate files to obtain the data on that\n");
  printf("\tanimal's cycle of the seminiferous epithelium.\n\n");
  printf("\tStages can access the data for the following animals:\n\n");
  printf("\t      1/  Sprague-Dawley Rat\n");
  printf("\t      2/  Sherman Rat\n");
  printf("\t      3/  Hamster\n");
  printf("\t      4/  C3H Mouse\n");
  printf("\t      5/  Dog\n\n");
  printf("\tStages cannot proceed until an animal is selected.\n");
  printline(0, LNWID, '-');
#endif
#if VERBOSE
  if (FILEq && FILECOPY) {
    fprintf(fpout, "\n\n");
    printline(1, LNWID, '-');
    fprintf(fpout, "\n\t\t    Help!: Using the Animal Menu\n\n");
    fprintf(fpout, "\tStages needs an animal type.  Once an animal has been selected,\n");
    fprintf(fpout, "\tStages can read the appropriate files to obtain the data on that\n");
    fprintf(fpout, "\tanimal's cycle of the seminiferous epithelium.\n\n");
    fprintf(fpout, "\tStages can access the data for the following animals:\n\n");
    fprintf(fpout, "\t      1/  Sprague-Dawley Rat\n");
    fprintf(fpout, "\t      2/  Sherman Rat\n");
    fprintf(fpout, "\t      3/  Hamster\n");
    fprintf(fpout, "\t      4/  C3H Mouse\n");
    fprintf(fpout, "\t      5/  Dog\n\n");
    fprintf(fpout, "\tStages cannot proceed until an animal is selected.\n");
    printline(1, LNWID, '-');
  }
#endif
  return(0);
} /* helpanimalmenu */

/**********************************/
/*     function: helpcyclelenip   */
/**********************************/
helpcyclelenip ()
{
#if PC
  int i;

  topline(" Help!: Entering a New Cycle Length ");
  clrscr1(1);
  normvideo();
  i = 2;
  gotoxy(1, i++);
  cprintf("%sStages uses the duration of the seminiferous epithelium, in days,", tab);
  gotoxy(1, i++);
  cprintf("%sin its computations.  Each animal has associated with it a default", tab);
  gotoxy(1, i++);
  cprintf("%scycle length, given in the literature.  Under certain experimental", tab);
  gotoxy(1, i++);
  cprintf("%sconditions, the cycle duration may be altered.", tab);
  i++;
  gotoxy(1, i++);
  cprintf("%sTo test for changes in the cycle duration, a new cycle length, in", tab);
  gotoxy(1, i++);
  cprintf("%sdays, can be entered if so desired.  Continued substitution of", tab);
  gotoxy(1, i++);
  cprintf("%snew cycle lengths, until the predicted data match the observed", tab);
  gotoxy(1, i++);
  cprintf("%sdata, can lead to an estimation of the altered cycle length.", tab);
  i++;
  if (strcmp(Animal, "None")) {
    gotoxy(1, i++);
    cprintf("%s     Default Cycle Length: %.2lf days", tab, CycleTime);
  }
  hitreturn(1);
  if (HARDCOPY) {
    togglepr();
    fprintf(stdprn, "\n\n");
    printline(2, LNWID, '-');
    fprintf(stdprn, "\n\t\t    Help!: Entering a New Cycle Length\n\n");
    fprintf(stdprn, "\tStages uses the duration of the seminiferous epithelium, in days,\n");
    fprintf(stdprn, "\tin its computations.  Each animal has associated with it a default\n");
    fprintf(stdprn, "\tcycle length, given in the literature.  Under certain experimental\n");
    fprintf(stdprn, "\tconditions, the cycle duration may be altered.\n\n");
    fprintf(stdprn, "\tTo test for changes in the cycle duration, a new cycle length, in\n");
    fprintf(stdprn, "\tdays, can be entered if so desired.  Continued substitution of\n");
    fprintf(stdprn, "\tnew cycle lengths, until the predicted data match the observed\n");
    fprintf(stdprn, "\tdata, can lead to an estimation of the altered cycle length.\n\n");
    if (strcmp(Animal, "None")) {
      fprintf(stdprn, "\t     Default Cycle Length: %.2lf days\n", CycleTime);
    }
    printline(2, LNWID, '-');
  }
#else
  printf("\n\n");
  printline(0, LNWID, '-');
  printf("\n\t\t    Help!: Entering a New Cycle Length\n\n");
  printf("\tStages uses the duration of the seminiferous epithelium, in days,\n");
  printf("\tin its computations.  Each animal has associated with it a default\n");
  printf("\tcycle length, given in the literature.  Under certain experimental\n");
  printf("\tconditions, the cycle duration may be altered.\n\n");
  printf("\tTo test for changes in the cycle duration, a new cycle length, in\n");
  printf("\tdays, can be entered if so desired.  Continued substitution of\n");
  printf("\tnew cycle lengths, until the predicted data match the observed\n");
  printf("\tdata, can lead to an estimation of the altered cycle length.\n\n");
  if (strcmp(Animal, "None"))
    printf("\t     Default Cycle Length: %.2lf days\n", CycleTime);
  printline(0, LNWID, '-');
#endif

#if VERBOSE
  if (FILEq && FILECOPY) {
    fprintf(fpout, "\n\n");
    printline(1, LNWID, '-');
    fprintf(fpout, "\n\t\t    Help!: Entering a New Cycle Length\n\n");
    fprintf(fpout, "\tStages uses the duration of the seminiferous epithelium, in days,\n");
    fprintf(fpout, "\tin its computations.  Each animal has associated with it a default\n");
    fprintf(fpout, "\tcycle length, given in the literature.  Under certain experimental\n");
    fprintf(fpout, "\tconditions, the cycle duration may be altered.\n\n");
    fprintf(fpout, "\tTo test for changes in the cycle duration, a new cycle length, in\n");
    fprintf(fpout, "\tdays, can be entered if so desired.  Continued substitution of\n");
    fprintf(fpout, "\tnew cycle lengths, until the predicted data match the observed\n");
    fprintf(fpout, "\tdata, can lead to an estimation of the altered cycle length.\n\n");
    if (strcmp(Animal, "None"))
      fprintf(fpout, "\t     Default Cycle Length: %.2lf days\n", CycleTime);
    printline(1, LNWID, '-');
  }
#endif
  return(0);
} /* helpcyclelenip */
